<template>
  <div style="height : 100%;">
    <div class="init-components">
      <template v-if="indexItemTab != 0">
        <div
          style="height : 100%;"
          :key="'container-code-mirror' + indexItemTab"
          :id="'container-code-mirror' + indexItemTab"
        >
          <CodeMirror :item-tab="itemTab" />
        </div>
        <div
          :id="'container-out-variables' + indexItemTab"
          :key="'container-out-variables' + indexItemTab"
        >
          <OutParams :item-tab="itemTab" />
        </div>
        <div
          :id="'container-out-error' + indexItemTab"
          :key="'container-out-error' + indexItemTab"
        >
          <OutError :item-tab="itemTab" />
        </div>
      </template>
    </div>
    <v-dialog v-model="itemTab.isDialogParams" persistent max-width="700px">
      <v-card>
        <v-card-title>
          <div class="titModal">
            <strong>Parámetros</strong>
          </div>
        </v-card-title>
        <Params ref="params" :item-tab="itemTab" />
        <v-card-actions>
          <v-row justify="center" style="margin-right:0px">
            <v-btn
              class="ma-2"
              dark
              tile
              depressed
              color="secondary"
              @click="itemTab.isDialogParams = false"
              >Atras</v-btn
            >
            <v-btn
              class="ma-2"
              depressed
              dark
              tile
              color="orange"
              @click="execute"
              >Ejecutar</v-btn
            >
          </v-row>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <template v-if="indexItemTab == 0">
      Home
    </template>
    <template v-else>
      <v-app-bar height="30">
        <v-btn icon color="green">
          <v-icon @click="existParamsRequest">mdi-play-circle</v-icon>
        </v-btn>
      </v-app-bar>
      <JqxDockingLayout
        ref="myDockingLayout"
        class="docking-layout"
        :layout="layout()"
      >
        <div data-container="WorkTab">
          <div
            style="height: 100%;"
            :id="'work-tab-' + indexItemTab"
            ref="workTab"
          ></div>
        </div>
        <div data-container="OutputPanel">
          <div
            :id="'out-variables-tab-' + indexItemTab"
            ref="outVariablesTab"
          ></div>
        </div>
        <div data-container="ErrorListPanel">
          <div :id="'out-error-tab-' + indexItemTab" ref="outErrorTab"></div>
        </div>
      </JqxDockingLayout>
    </template>
  </div>
</template>
<style scoped>
@import "~jqwidgets-scripts/jqwidgets/styles/jqx.base.css";
@import "~jqwidgets-scripts/jqwidgets/styles/jqx.material.css";
/*@import "~jqwidgets-scripts/jqwidgets/styles/jqx.oranges.css";*/
.init-components {
  display: none;
}
.docking-layout {
  width: 100%;
  height: calc(100% - 29px);
}
</style>
<script>
import axios from "axios";
import JqxDockingLayout from "jqwidgets-scripts/jqwidgets-vue/vue_jqxdockinglayout.vue";
import CodeMirror from "@/views/secure/pro/CodeMirror.vue";
import Params from "@/views/secure/pro/Params.vue";
import OutParams from "@/views/secure/pro/OutParams.vue";
import OutError from "@/views/secure/pro/OutError.vue";
export default {
  name: "Component-Tab",
  props: {
    indexItemTab: Number,
    itemTab: Object
  },
  components: {
    JqxDockingLayout,
    CodeMirror,
    Params,
    OutParams,
    OutError
  },
  data: () => ({
    theme: "material"
  }),
  methods: {
    layout() {
      return [
        {
          type: "layoutGroup",
          orientation: "vertical",
          items: [
            {
              type: "documentGroup",
              height: "75%",
              minHeight: 400,
              items: [
                {
                  type: "documentPanel",
                  title: "Hoja de trabajo",
                  contentContainer: "WorkTab",
                  initContent: () => {
                    let workTab = document.getElementById(
                      "work-tab-" + this.indexItemTab
                    );
                    let containerCodeMirror = document.getElementById(
                      "container-code-mirror" + this.indexItemTab
                    );
                    workTab.appendChild(containerCodeMirror);
                  }
                }
              ]
            },
            {
              type: "tabbedGroup",
              height: "25%",
              minHeight: 200,
              pinnedHeight: 30,
              items: [
                {
                  type: "layoutPanel",
                  title: "Salida",
                  contentContainer: "OutputPanel",
                  selected: true,
                  initContent: () => {
                    let outVariablesTab = document.getElementById(
                      "out-variables-tab-" + this.indexItemTab
                    );
                    let containerOutVariables = document.getElementById(
                      "container-out-variables" + this.indexItemTab
                    );
                    outVariablesTab.appendChild(containerOutVariables);
                  }
                },
                {
                  type: "layoutPanel",
                  title: "Errores",
                  contentContainer: "ErrorListPanel",
                  initContent: () => {
                    let outErrorTab = document.getElementById(
                      "out-error-tab-" + this.indexItemTab
                    );
                    let containerOutError = document.getElementById(
                      "container-out-error" + this.indexItemTab
                    );
                    outErrorTab.appendChild(containerOutError);
                  }
                }
              ]
            }
          ]
        }
      ];
    },
    existParamsRequest() {
      if (
        this.itemTab.plsql.includes("in:") ||
        this.itemTab.plsql.includes("out:")
      ) {
        this.itemTab.isDialogParams = true;
      } else {
        this.execute();
      }
    },
    execute() {
      const self = this;
      const itemTab = this.itemTab;
      itemTab.isDialogParams = false;
      itemTab.clearOutParams(itemTab);
      itemTab.clearOutError(itemTab);
      itemTab.isLoading = true;
      let plsql = itemTab.plsql.replace(/in:/g, ":");
      plsql = itemTab.plsql.replace(/out:/g, ":");
      const params = {
        properties: itemTab.properties,
        register_parameters: itemTab.params,
        plsql: plsql
      };
      axios
        .post("oracle/execute", params)
        .then((response) => {
          if (response) {
            const data = response.data.data;
            if (data) {
              self.setOuput(data);
            } else {
              itemTab.outError = response.data.error.message;
              itemTab.isOutError = true;
            }
          }
        })
        .catch((error) => {
          itemTab.outError = error;
          itemTab.isOutError = true;
          console.log(error);
        })
        .finally(function() {
          itemTab.isLoading = false;
        });
    },
    setOuput(output) {
      let outParams = {
        grids: [],
        simple: []
      };
      for (let index in output) {
        let item = output[index];
        let isArray = Array.isArray(item);
        if (isArray) {
          let headers = [];
          if (item.length >= 0) {
            let templateHeader = item[0];
            for (let header in templateHeader) {
              headers.push({ text: header, value: header });
            }
          }
          outParams.grids.push({
            search: null,
            name: index,
            rows: item,
            headers
          });
        } else {
          outParams.simple.push({ name: index, value: item });
        }
      }
      this.itemTab.outParams = outParams;
    }
  }
};
</script>
